# Simple captcha module

## Description

This module provides a simple captcha ("Completely Automated Public Turing test to tell Computers and Humans Apart")
challenge (distorted characters in an image).

It is used to ensure that only a user who can read the distorted characters and enter them in the related input field
can submit the following forms:
 - contact
 - invite
 - pricealarm
 - suggest

The captcha module then validates the submitted value against the expected one and then decides whether to process the
request (e.g. send contact mail to shop administrator) or refuse and show an error message instead.

## Installation

Please proceed with one of the following ways to install the module:

### Module installation

In order to install the module via composer, run the following commands in commandline of your shop base directory 
(where the shop's composer.json file resides).

```
composer require oxid-projects/captcha-module
```

### Adjustments of shop theme

Depending of the installed theme, required tpl blocks may be missing. Please add the missing blocks (as described in metadata.php) to the shop theme templates.

Exceptions:
`tpl/form/fieldset/user_billing.tpl` - wrap block with this condition:

```
[{if $blIsRegister == true}]
    [{block name="captcha_form"}][{/block}]
[{/if}]
```

`tpl/form/register.tpl` - insert the variable to the include command:

```
[{include file="form/fieldset/user_billing.tpl" blIsRegister=true}]
```

## Activate Module

- Activate the module in the administration panel.

## Occurrences (test cases)

- from user_billing.tpl block extension
  - form/user_checkout_noregistration.tpl
    - checkout/user.tpl (no login && order without account)
  - form/user_checkout_registration.tpl
    - checkout/user.tpl (no login && create account)
  - form/user_checkout_change.tpl
    - checkout/user.tpl (logged in)
  - form/register.tpl
    - page/account/register.tpl
  - form/user.tpl
    - page/account/user.tpl
- ... to be continued

## Uninstall

Disable the module in administration area and delete the module folder.

## License

Licensing of the software product depends on the shop edition used. The software for OXID eShop Community Edition
is published under the GNU General Public License v3. You may distribute and/or modify this software according to
the licensing terms published by the Free Software Foundation. Legal licensing terms regarding the distribution of
software being subject to GNU GPL can be found under http://www.gnu.org/licenses/gpl.html. The software for OXID eShop
Professional Edition and Enterprise Edition is released under commercial license. OXID eSales AG has the sole rights to
the software. Decompiling the source code, unauthorized copying as well as distribution to third parties is not
permitted. Infringement will be reported to the authorities and prosecuted without exception.
